import java.awt.Color;
import edu.kzoo.grid.ColorBlock;
import edu.kzoo.util.Debug;

/**
 *  Percolation Program:<br>
 *
 *  A SolidCell object represents solid material through which gas or liquid
 *  cannot percolate (such as rocks in soil).
 *
 *  @author Alyce Brady
 *  @version 21 May 2017
 */
public class SolidCell extends ColorBlock
{
    // instance variables
    //     NO new state -- inherits state from ColorBlock

    /** Constructs a solid cell object with the default color
     *  Color.BLACK.
     */
    public SolidCell()
    {
        super(Color.BLACK);     // invoke superclass constructor
    }

    /** Constructs a solid cell object with the given color.
     *  @param cellColor   the color for this cell
     */
    public SolidCell(Color cellColor)
    {
        super(cellColor);     // invoke superclass constructor
    }

  // redefined method from GridObject

    /** Acts for one step in the percolation simulation.
     */
    @Override
    public void act()
    {
        Debug.println("Solid Cell " + location() + " not acting.");
    }

}
